#ifndef _WXJALAKFRAME_H
#define _WXJALAKFRAME_H

#include <wx/wxprec.h>

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "wxJalakViewer.h"

class wxJalakFrame : public wxFrame {
private:
    wxToolBar* fToolBar;
    wxStatusBar* fStatBar;
    wxJalakViewer* fViewer;
    wxApp* fOwner;
    wxSlider* fHeightSliders[25];
    
    enum { kID_MAX, kID_MID, kID_MIN, kID_RAND };

public:
    wxJalakFrame(wxApp* owner);
    ~wxJalakFrame();

    void LoadFile(const wxChar* filename);
    void SaveFile(const wxChar* filename);

private:
    void SetupSliders();

// Event handling stuff //
private: DECLARE_EVENT_TABLE()
public:
    void OnOpenClick(wxCommandEvent& evt);
    void OnSaveClick(wxCommandEvent& evt);
    
    void OnMinClick(wxCommandEvent& evt);
    void OnMidClick(wxCommandEvent& evt);
    void OnMaxClick(wxCommandEvent& evt);
    void OnRandClick(wxCommandEvent& evt);
    
    void OnSlide(wxScrollEvent& evt);
};

#endif
