#ifndef _WXJALAKVIEWER_H
#define _WXJALAKVIEWER_H

#include <wx/wxprec.h>

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/glcanvas.h>

typedef unsigned char jheight_t;

class wxJalakViewer : public wxGLCanvas {
private:
    bool fInited;
    jheight_t fHeights[5][5];
    float fViewX, fViewZ;
    wxPoint fMouseFrom;

public:
    wxJalakViewer(wxWindow* parent, wxWindowID id = wxID_ANY,
                  const wxPoint& pos = wxDefaultPosition,
                  const wxSize& size = wxDefaultSize,
                  long style = 0, const wxString& name = wxT("Viewer"));
    ~wxJalakViewer();

    void Render();

    void SetMinHeights();
    void SetMidHeights();
    void SetMaxHeights();
    void SetRandHeights();
    
    jheight_t Get(int x, int y) const;
    void Set(int x, int y, jheight_t height);

private:
    void DrawBar(int x, int y);
    
// Event handling //
private: DECLARE_EVENT_TABLE()
public:
    void OnPaint(wxPaintEvent& evt);
    void OnSize(wxSizeEvent& evt);
    void OnEraseBackground(wxEraseEvent& evt);
    
    void OnMouse(wxMouseEvent& evt);
};

#endif
